<template>
  <b-container class="mt-5">
    <b-row>
      <b-col cols="12" md="6" class="mx-auto">
        <b-card title="Registration">
          <b-form @submit.prevent="register">
            <b-form-group label="Username:" label-for="username-input">
              <b-form-input
                id="username-input"
                v-model="username"
                type="text"
                placeholder="Enter username"
                required
              ></b-form-input>
            </b-form-group>

            <b-form-group label="E-mail:" label-for="email-input">
              <b-form-input
                id="email-input"
                v-model="email"
                type="email"
                placeholder="Enter e-mail"
                required
              ></b-form-input>
            </b-form-group>

            <b-form-group label="Password:" label-for="password-input">
              <b-form-input
                id="password-input"
                v-model="password"
                type="password"
                placeholder="Enter password"
                required
              ></b-form-input>
            </b-form-group>

            <b-button type="submit" variant="primary" :disabled="loading"
              >Register
            </b-button>
          </b-form>
        </b-card>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import { register } from '@/provider/provider';

export default {
  name: 'UserRegistration',
  data() {
    return {
      username: '',
      email: '',
      password: '',
      loading: false,
    };
  },
  methods: {
    async register() {
      this.loading = true;
      try {
        let response = await register(this.username, this.email, this.password);
        if (response.status) {
          this.$router.push('/notification');
        }
      } catch (error) {
        alert('Registration error');
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>
